<template>
  <div id="app">
    <div class="nav" v-bind:class="{ nav_layoutOpen: open }">
      <img src="./assets/moon.jpg" @click="toggleLayout" />
      <router-link to="/">Home</router-link>
      <router-link to="/tops">Tops</router-link>
      <router-link to="/search">Search</router-link>
      <router-link to="/about">About</router-link>
      <div class="dataState">
        <p>Data state :</p>
        <img v-if="loading" src="@/assets/loader.gif" alt="spinning_loader" />
        <img v-else src="@/assets/checkmark.png" alt="checkmark" />
      </div>
    </div>

    <router-view class="content" v-bind:class="{ content_layoutOpen: open }" />
  </div>
</template>

<script>
import Axios from "axios";

export default {
  name: "App",
  data() {
    return {
      open: false,
      loading: true
    };
  },
  methods: {
    toggleLayout() {
      this.open = !this.open;
    }
  },
  created() {
    const apiUri = "https://api.le-systeme-solaire.net/rest/bodies";
    this.loading = false;
    Axios.get(apiUri)
      .then(response => {
        this.$store.commit("setAllData", response.data);
        this.loading = false;
      })
      .catch(error => {
        alert("Api error" + error);
      });
  }
};
</script>

<style lang="scss">
body {
  margin: 0;
  padding: 0;
}

#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #f3f3f3;
  background: teal;

  display: flex;

  width: 100vw;
  height: 100vh;
}

.nav {
  grid-area: nav;
  width: 7.5%;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  align-items: center;

  * {
    margin: 25px 10px;
  }

  img {
    object-fit: cover;
    width: 100%;
    margin: 0;
  }

  a {
    font-weight: bold;
    color: #2c3e50;

    &.router-link-exact-active {
      color: #42b983;
    }
  }
}
.nav_layoutOpen {
  width: 12.5%;
}

.content {
  width: 92.5%;
}
.content_layoutOpen {
  width: 87.5%;
}
</style>
